import java.io.*;

/* 
This is a simple class which is used to demonstrate multithreading.  The class
is initialized with an integer and a queue.  The integer is used to set a
sleep time.  Execution of the thread proceeds in rounds, and proceeds
infinitely.  In each round, the thread prints out the duration of its sleep
time, inserts its sleep time plus its round number into a queue, then sleeps
for its sleep time.

*/

class Foo implements Runnable {
  
  int mySleepTime;
  Queue externalQueue;
  Foo (int i, Queue q) {
    mySleepTime = i;
    externalQueue = q;
  }

  public void run() {
    int round = 0;
    while (true) {
      System.out.println("foo: "+mySleepTime);
      externalQueue.add(new Integer(mySleepTime+round));
      try { Thread.sleep(mySleepTime);
      } catch (Exception e) { 
        // silly exception, died in sleep?
      }
      round ++;
    }
  }
}
