import java.io.*;


/* 
This class demonstrates simple multithreading, and synchronization using the
Queue object.  It works by starting three independent threads from the Starter
class.  After this, the starter effectively waits for messages from those
other threads.  The "messages" are in the form of Integer objects in a shared
queue.  When the Starter sees an object in the Queue, it is removed, and the
value printed to the screen.

To run this program, compile Starter.java, Foo.java, and Queue.java.  Then
execute with:
    java Starter


*/

public class Starter {

  public static void main (String[] args) {
    Queue q = new Queue();
    // create and start a foo object
    new Thread(new Foo(1000, q)).start();  
    // create and start another foo object
    new Thread(new Foo(2000, q)).start();  
    // create and start another foo object
    new Thread(new Foo(3000, q)).start();  
    Integer i;

    while (true) {
      i = (Integer)q.remove();
      System.out.println("Starter: "+ i);
    }
  }
}
